package org.greenstone.gsdl3.util;

import org.w3c.dom.Node;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.Document;
import org.w3c.dom.Text;

import java.util.HashMap;

/** various functions for manipulating Greenstone xslt  */
public class GSXSLT {

    /** takes a stylesheet Document, and adds in any child nodes from extra_xsl
     */
    public static void mergeStylesheets(Document main_xsl, Element extra_xsl) {
	
	Element main = main_xsl.getDocumentElement();
	
	NodeList children = extra_xsl.getChildNodes();
	for (int i=0; i<children.getLength(); i++) {
	     main.appendChild(main_xsl.importNode(children.item(i), true));
	}

    }

    /** takes any import or include nodes, and creates absolute path names
     * for the files
     */
    public static void absoluteIncludePaths(Document stylesheet, 
					 ConfigVars config) {
	
	
	Element base_node = stylesheet.getDocumentElement();
	Node child = base_node.getFirstChild();
	while(child != null) {
	    String name = child.getNodeName();
	    if (name.equals("xsl:import") || name.equals("xsl:include")) {
		((Element)child).setAttribute("href", GSFile.stylesheetFile(config, ((Element)child).getAttribute("href")));
	    }
	    child = child.getNextSibling();
	}
	
    }
}
